'**************************************************************************
'*                       MSSetup For IN3
'**************************************************************************

'$INCLUDE 'setupapi.inc'
'$INCLUDE 'msdetect.inc'

''Dialog ID's
CONST WELCOME      = 100
CONST ASKQUIT      = 200
CONST EXITFAILURE  = 400
CONST EXITQUIT     = 600
CONST EXITSUCCESS  = 700
CONST OPTIONS      = 800
CONST APPHELP      = 900
CONST AUDPATH      = 1000
CONST LEXPATH      = 1100

''Bitmap ID
CONST LOGO         = 1

''File Types
CONST APPFILES     = 1
CONST LEXFILES     = 2
CONST AUDFILES     = 3
''Pseudo File types (controls Program Grouping)
CONST ADDACC       = 4
CONST CREATIN3     = 5


DECLARE FUNCTION MakePath (szDir$, szFile$) AS STRING


INIT:
    CUIDLL$ = "mscuistf.dll"            ''custom user interface dll
    HELPPROC$ = "FHelpDlgProc"          ''Help dialog procedure

    SetBitmap CUIDLL$, LOGO
    SetTitle "IN3 Voice Command System Setup"

    szInf$ = GetSymbolValue("STF_SRCINFPATH")
    IF szInf$ = "" THEN
        szInf$ = GetSymbolValue("STF_CWDDIR") + "IN3.INF"
    END IF
    ReadInfFile szInf$

    szSrc$ = GetSymbolValue("STF_SRCDIR")


WELCOME:
    sz$ = UIStartDlg(CUIDLL$, WELCOME, "FInfoDlgProc", APPHELP, HELPPROC$)
    IF sz$ = "CONTINUE" THEN
        UIPop 1
    ELSE
        GOSUB ASKQUIT
        GOTO WELCOME
    END IF


    WINDRIVE$ = MID$(GetWindowsDir, 1, 1)
    WINPATH$ = GetWindowsDir
    WINSYSTEM$ = GetWindowsSysDir
    OLDDLL$ = MakePath( WINSYSTEM$, "vrsdll.dll" )
    IF DoesFileExist( OLDDLL$, femRead ) THEN
        RemoveFile OLDDLL$, cmoNone
    END IF
    OLDDLL$ = MakePath( WINSYSTEM$, "vrsi.dll" )
    IF DoesFileExist( OLDDLL$, femRead ) THEN
        RemoveFile OLDDLL$, cmoNone
    END IF
    OLDDLL$ = MakePath( WINSYSTEM$, "vrl.dll" )
    IF DoesFileExist( OLDDLL$, femRead ) THEN
        RemoveFile OLDDLL$, cmoNone
    END IF
    OLDDLL$ = MakePath( WINSYSTEM$, "vrswave.dll" )
    IF DoesFileExist( OLDDLL$, femRead ) THEN
        RemoveFile OLDDLL$, cmoNone
    END IF
    OLDDLL$ = MakePath( WINSYSTEM$, "vrsi.dll" )
    IF DoesFileExist( OLDDLL$, femRead ) THEN
        RemoveFile OLDDLL$, cmoNone
    END IF
    OLDDLL$ = MakePath( WINPATH$, "vrl.dll" )
    IF DoesFileExist( OLDDLL$, femRead ) THEN
        RemoveFile OLDDLL$, cmoNone
    END IF
    OLDDLL$ = MakePath( WINPATH$, "vrsdemo.exe" )
    IF DoesFileExist( OLDDLL$, femRead ) THEN
        RemoveFile OLDDLL$, cmoNone
    END IF
    OLDDLL$ = MakePath( WINPATH$, "in3demo.exe" )
    IF DoesFileExist( OLDDLL$, femRead ) THEN
        RemoveFile OLDDLL$, cmoNone
    END IF
    OLDDLL$ = MakePath( WINPATH$, "in3.exe" )
    IF DoesFileExist( OLDDLL$, femRead ) THEN
        RemoveFile OLDDLL$, cmoNone
    END IF
    OLDDLL$ = MakePath( WINPATH$, "vrs.exe" )
    IF DoesFileExist( OLDDLL$, femRead ) THEN
        RemoveFile OLDDLL$, cmoNone
    END IF

    ini$ = MakePath(WINPATH$, "IN3.INI")
    iniold$ = MakePath(szSrc$, "IN3INI.OLD")

    IF DoesFileExist( ini$, femRead ) THEN
        DESTLEX$=GetIniKeyString( ini$, "In3", "LexiconPath" )
        LEXICON$=GetIniKeyString( ini$, "In3", "Lexicon" )
        DESTAUD$=GetIniKeyString( ini$, "In3", "AudioPath" )
        TOPMOST$=GetIniKeyString( ini$, "In3", "TopMost" )
        AUDIOMSG$=GetIniKeyString( ini$, "In3", "AudioMsgs" )
        CopyFile ini$, iniold$, cmoNone, 0
	RemoveFile ini$, cmoNone
    END IF

    ini$ = MakePath( szSrc$, "IN3.INI" )
    iniold$ = MakePath( szSrc$, "IN3INI.INI" )

    IF DoesFileExist( ini$, femRead ) = 0 THEN
	RenameFile iniold$, "IN3.INI"
    END IF

    IF DoesFileExist( iniold$, femRead ) = 0 THEN
	RemoveFile iniold$, cmoNone
    END IF

    IF DESTLEX$ = "" THEN
        DESTLEX$ = szSrc$
    ELSEIF DoesDirExist( DESTLEX$ ) = 0 THEN
        DESTLEX$ = szSrc$
    END IF

    IF MID$(DESTLEX$, LEN(DESTLEX$), 1) <> "\" THEN
        DESTLEX$ = DESTLEX$ + "\"
    END IF

    IF DESTAUD$ = "" THEN
        DESTAUD$ = DESTLEX$ + "AUDIO\"
    END IF

    IF MID$(DESTAUD$, LEN(DESTAUD$), 1) <> "\" THEN
        DESTAUD$ = DESTAUD$ + "\"
    END IF

    IF DoesDirExist( DESTAUD$ ) = 0 THEN
	DESTAUD$ = szSrc$
    ELSEIF DoesFileExist( MakePath( DESTAUD$, "IN3READY.WAV" ), femRead ) = 0 THEN
	DESTAUD$ = szSrc$
    END IF

    IF TOPMOST$ = "" THEN
	TOPMOST$ = "0"
    END IF

    IF LEXICON$ = "" THEN
	LEXICON$ = "DEMO"
    END IF

    IF AUDIOMSG$ = "" THEN
	AUDIOMSG$ = "1"
    END IF

INSTALL:
    CreateIniKeyValue ini$, "In3", "TopMost", TOPMOST$ , cmoNone

    CreateIniKeyValue ini$, "In3", "Lexicon", LEXICON$ , cmoNone
    CreateIniKeyValue ini$, "In3", "Path", MakePath( szSrc$, "" ) , cmoNone
    CreateIniKeyValue ini$, "In3", "LexiconPath", MakePath( DESTLEX$, "" ) , cmoOverwrite
    CreateIniKeyValue ini$, "In3", "InstallPath", MakePath( szSrc$, "" ) , cmoOverwrite

    CreateIniKeyValue ini$, "In3", "AudioMsg", AUDIOMSG$  , cmoNone
    CreateIniKeyValue ini$, "In3", "AudioPath", MakePath( DESTAUD$, "" ) , cmoOverwrite

    PMGROUP$="IN3"
    CreateProgmanGroup "IN3", "", cmoNone
    ShowProgmanGroup  PMGROUP$, 1, cmoNone

    CreateProgmanItem PMGROUP$, "IN3", MakePath( szSrc$, "in3.exe "), "", cmoOverwrite
    CreateProgmanItem PMGROUP$, "IN3 HELP", MakePath( WINPATH$, "winhelp.exe " + MakePath( szSrc$, "in3.hlp" ) ), "", cmoOverwrite
    CreateProgmanItem PMGROUP$, "IN3 Manual", MakePath( WINPATH$, "winhelp.exe " + MakePath( szSrc$, "in3man.hlp" ) ), "", cmoOverwrite
    CreateProgmanItem PMGROUP$, "Release Notes", MakePath( WINPATH$, "write.exe " + MakePath( szSrc$, "release.wri" ) ), "", cmoOverwrite

QUIT:
    ON ERROR GOTO ERRQUIT

    IF ERR = 0 THEN
        dlg% = EXITSUCCESS
    ELSEIF ERR = STFQUIT THEN
        dlg% = EXITQUIT
    ELSE
        dlg% = EXITFAILURE
    END IF
QUITL1:
    sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        GOTO QUITL1
    END IF
    UIPop 1

    END

ERRQUIT:
    i% = DoMsgBox("Setup sources were corrupted, call (404)813-8030!", "Setup Message", MB_OK+MB_TASKMODAL+MB_ICONHAND)
    END



ASKQUIT:
    sz$ = UIStartDlg(CUIDLL$, ASKQUIT, "FQuitDlgProc", 0, "")

    IF sz$ = "EXIT" THEN
        UIPopAll
        ERROR STFQUIT
    ELSEIF sz$ = "REACTIVATE" THEN
        GOTO ASKQUIT
    ELSE
        UIPop 1
    END IF
    RETURN



'**
'** Purpose:
'**     Appends a file name to the end of a directory path,
'**     inserting a backslash character as needed.
'** Arguments:
'**     szDir$  - full directory path (with optional ending "\")
'**     szFile$ - filename to append to directory
'** Returns:
'**     Resulting fully qualified path name.
'*************************************************************************
FUNCTION MakePath (szDir$, szFile$) STATIC AS STRING
    IF szDir$ = "" THEN
        MakePath = szFile$
    ELSEIF szFile$ = "" THEN
        MakePath = szDir$
    ELSEIF MID$(szDir$, LEN(szDir$), 1) = "\" THEN
        MakePath = szDir$ + szFile$
    ELSE
        MakePath = szDir$ + "\" + szFile$
    END IF
END FUNCTION

